Index: /TOOLS/MOSAIX/nemo.py
===================================================================
--- /TOOLS/MOSAIX/nemo.py	(revision 6665)
+++ /TOOLS/MOSAIX/nemo.py	(revision 6666)
@@ -162,370 +215,555 @@
     Credits : who is the original author ?
     '''
-    gP = None
+
+    gp = None
     mmath = __mmath__ (ptab)
     if mmath == xr :
-        if 'x_c' in ptab.dims and 'y_c' in ptab.dims                        : gP = 'T'
-        if 'x_f' in ptab.dims and 'y_c' in ptab.dims                        : gP = 'U'
-        if 'x_c' in ptab.dims and 'y_f' in ptab.dims                        : gP = 'V'
-        if 'x_f' in ptab.dims and 'y_f' in ptab.dims                        : gP = 'F'
-        if 'x_c' in ptab.dims and 'y_c' in ptab.dims and 'z_c' in ptab.dims : gP = 'T'
-        if 'x_c' in ptab.dims and 'y_c' in ptab.dims and 'z_f' in ptab.dims : gP = 'W'
-        if 'x_f' in ptab.dims and 'y_c' in ptab.dims and 'z_f' in ptab.dims : gP = 'U'
-        if 'x_c' in ptab.dims and 'y_f' in ptab.dims and 'z_f' in ptab.dims : gP = 'V'
-        if 'x_f' in ptab.dims and 'y_f' in ptab.dims and 'z_f' in ptab.dims : gP = 'F'
-             
-        if gP == None :
-            raise Exception ('in nemo module : cd_type not found, and cannot by guessed')
-        else :
-            print ('Grid set as', gP, 'deduced from dims ', ptab.dims)
-            return gP
-    else :
-         raise Exception  ('in nemo module : cd_type not found, input is not an xarray data')
+        if ('x_c' in ptab.dims and 'y_c' in ptab.dims ) :
+            gp = 'T'
+        if ('x_f' in ptab.dims and 'y_c' in ptab.dims ) :
+            gp = 'U'
+        if ('x_c' in ptab.dims and 'y_f' in ptab.dims ) :
+            gp = 'V'
+        if ('x_f' in ptab.dims and 'y_f' in ptab.dims ) :
+            gp = 'F'
+        if ('x_c' in ptab.dims and 'y_c' in ptab.dims
+              and 'z_c' in ptab.dims )                :
+            gp = 'T'
+        if ('x_c' in ptab.dims and 'y_c' in ptab.dims
+                and 'z_f' in ptab.dims )                :
+            gp = 'W'
+        if ('x_f' in ptab.dims and 'y_c' in ptab.dims
+                and 'z_f' in ptab.dims )                :
+            gp = 'U'
+        if ('x_c' in ptab.dims and 'y_f' in ptab.dims
+                and 'z_f' in ptab.dims ) :
+            gp = 'V'
+        if ('x_f' in ptab.dims and 'y_f' in ptab.dims
+                and 'z_f' in ptab.dims ) :
+            gp = 'F'
+
+        if gp is None :
+            raise AttributeError ('in nemo module : cd_type not found, and cannot by guessed')
+        print ( f'Grid set as {gp} deduced from dims {ptab.dims}' )
+        return gp
+    else :
+        raise AttributeError  ('in nemo module : cd_type not found, input is not an xarray data')
+
+def get_shape ( ptab ) :
+    '''Get shape of ptab return a string with axes names
+
+    shape may contain X, Y, Z or T
+    Y is missing for a latitudinal slice
+    X is missing for on longitudinal slice
+    etc ...
+    '''
+
+    g_shape = ''
+    if __find_axis__ (ptab, 'x')[0] :
+        g_shape = 'X'
+    if __find_axis__ (ptab, 'y')[0] :
+        g_shape = 'Y' + g_shape
+    if __find_axis__ (ptab, 'z')[0] :
+        g_shape = 'Z' + g_shape
+    if __find_axis__ (ptab, 't')[0] :
+        g_shape = 'T' + g_shape
+    return g_shape
 
 def lbc_diag (nperio) :
-    lperio = nperio ; aperio = False
+    '''Useful to switch between field with and without halo'''
+    lperio, aperio = nperio, False
     if nperio == 4.2 :
-        lperio = 4 ; aperio = True
+        lperio, aperio = 4, True
     if nperio == 6.2 :
-        lperio = 6 ; aperio = True
-        
-    return lperio, aperio 
-
-def __findAxis__ (tab, axis='z') :
-    '''
-    Find number and name of the requested axis
-    '''
-    mmath = __mmath__ (tab)
-    ix = None ; ax = None
-
-    if axis in xList :
-        axList = [ 'x', 'X',
-                   'lon', 'nav_lon', 'nav_lon_T', 'nav_lon_U', 'nav_lon_V', 'nav_lon_F', 'nav_lon_W',
-                   'x_grid_T', 'x_grid_U', 'x_grid_V', 'x_grid_F', 'x_grid_W',
-                   'glam', 'glamt', 'glamu', 'glamv', 'glamf', 'glamw' ]
-        unList = [ 'degrees_east' ]
-    if axis in yList :
-        axList = [ 'y', 'Y', 'lat',
-                   'nav_lat', 'nav_lat_T', 'nav_lat_U', 'nav_lat_V', 'nav_lat_F', 'nav_lat_W',
-                   'y_grid_T', 'y_grid_U', 'y_grid_V', 'y_grid_F', 'y_grid_W',
-                   'gphi', 'gphi', 'gphiu', 'gphiv', 'gphif', 'gphiw']
-        unList = [ 'degrees_north' ]
-    if axis in zList :
-        axList = [ 'z', 'Z',
-                   'depth', 'deptht', 'depthu', 'depthv', 'depthf', 'depthw',
-                   'olevel' ]
-        unList = [ 'm', 'meter' ]
-    if axis in tList :
-        axList = [ 't', 'T', 'time', 'time_counter' ]
-        unList = [ 'second', 'minute', 'hour', 'day', 'month' ]
-    
+        lperio, aperio = 6, True
+    return lperio, aperio
+
+def __find_axis__ (ptab, axis='z', back=True) :
+    '''Returns name and name of the requested axis'''
+    mmath = __mmath__ (ptab)
+    ax, ix = None, None
+
+    if axis in XNAME :
+        ax_name, unit_list, length = XNAME, XUNIT, XLENGTH
+    if axis in YNAME :
+        ax_name, unit_list, length = YNAME, YUNIT, YLENGTH
+    if axis in ZNAME :
+        ax_name, unit_list, length = ZNAME, ZUNIT, ZLENGTH
+    if axis in TNAME :
+        ax_name, unit_list, length = TNAME, TUNIT, None
+
     if mmath == xr :
-        for Name in axList :
-            try    :
-                ix = tab.dims.index (Name)
-                ax = Name
-            except : pass
-
-        for i, dim in enumerate (tab.dims) :
-            if 'units' in tab.coords[dim].attrs.keys() :
-                for name in unList :
-                    if name in tab.coords[dim].attrs['units'] :
-                        ix = i
-                        ax = dim
-    else :
-        if axis in xList : ix=-1
-        if axis in yList :
-            if len(tab.shape) >= 2 : ix=-2
-        if axis in zList :
-            if len(tab.shape) >= 3 : ix=-3
-        if axis in tList :
-            if len(tab.shape) >=3  : ix=-3
-            if len(tab.shape) >=4  : ix=-4
-       
-    return ix, ax
-
-#@numba.jit(forceobj=True)
-def fixed_lon (lon, center_lon=0.0) :
-    '''
-    Returns corrected longitudes for nicer plots
+        # Try by name
+        for dim in ax_name :
+            if dim in ptab.dims :
+                ix, ax = ptab.dims.index (dim), dim
+
+        # If not found, try by axis attributes
+        if not ix :
+            for i, dim in enumerate (ptab.dims) :
+                if 'axis' in ptab.coords[dim].attrs.keys() :
+                    l_axis = ptab.coords[dim].attrs['axis']
+                    if axis in ax_name and l_axis == 'X' :
+                        ix, ax = (i, dim)
+                    if axis in ax_name and l_axis == 'Y' :
+                        ix, ax = (i, dim)
+                    if axis in ax_name and l_axis == 'Z' :
+                        ix, ax = (i, dim)
+                    if axis in ax_name and l_axis == 'T' :
+                        ix, ax = (i, dim)
+
+        # If not found, try by units
+        if not ix :
+            for i, dim in enumerate (ptab.dims) :
+                if 'units' in ptab.coords[dim].attrs.keys() :
+                    for name in unit_list :
+                        if name in ptab.coords[dim].attrs['units'] :
+                            ix, ax = i, dim
+
+    # If numpy array or dimension not found, try by length
+    if mmath != xr or not ix :
+        if length :
+            l_shape = ptab.shape
+            for nn in np.arange ( len(l_shape) ) :
+                if l_shape[nn] in length :
+                    ix = nn
+
+    if ix and back :
+        ix -= len(ptab.shape)
+
+    return ax, ix
+
+def find_axis ( ptab, axis='z', back=True ) :
+    '''Version of find_axis with no __'''
+    ix, xx = __find_axis__ (ptab, axis, back)
+    return xx, ix
+
+def fixed_lon (plon, center_lon=0.0) :
+    '''Returns corrected longitudes for nicer plots
 
     lon        : longitudes of the grid. At least 2D.
     center_lon : center longitude. Default=0.
 
-    Designed by Phil Pelson. See https://gist.github.com/pelson/79cf31ef324774c97ae7
-    '''
-    mmath = __mmath__ (lon)
+    Designed by Phil Pelson.
+    See https://gist.github.com/pelson/79cf31ef324774c97ae7
+    '''
+    mmath = __mmath__ (plon)
+
+    f_lon = plon.copy ()
+
+    f_lon = mmath.where (f_lon > center_lon+180., f_lon-360.0, f_lon)
+    f_lon = mmath.where (f_lon < center_lon-180., f_lon+360.0, f_lon)
+
+    for i, start in enumerate (np.argmax (np.abs (np.diff (f_lon, axis=-1)) > 180., axis=-1)) :
+        f_lon [..., i, start+1:] += 360.
+
+    # Special case for eORCA025
+    if f_lon.shape [-1] == 1442 :
+        f_lon [..., -2, :] = f_lon [..., -3, :]
+    if f_lon.shape [-1] == 1440 :
+        f_lon [..., -1, :] = f_lon [..., -2, :]
+
+    if f_lon.min () > center_lon :
+        f_lon += -360.0
+    if f_lon.max () < center_lon :
+        f_lon +=  360.0
+
+    if f_lon.min () < center_lon-360.0 :
+        f_lon +=  360.0
+    if f_lon.max () > center_lon+360.0 :
+        f_lon += -360.0
+
+    return f_lon
+
+def bounds_clolon ( pbounds_lon, plon, rad=False, deg=True) :
+    '''Choose closest to lon0 longitude, adding/substacting 360Â° if needed
+    '''
+
+    if rad :
+        lon_range = 2.0*np.pi
+    if deg :
+        lon_range = 360.0
+    b_clolon = pbounds_lon.copy ()
+
+    b_clolon = xr.where ( b_clolon < plon-lon_range/2.,
+                          b_clolon+lon_range,
+                          b_clolon )
+    b_clolon = xr.where ( b_clolon > plon+lon_range/2.,
+                          b_clolon-lon_range,
+                          b_clolon )
+    return b_clolon
+
+def unify_dims ( dd, x='x', y='y', z='olevel', t='time_counter', verbose=False ) :
+    '''Rename dimensions to unify them between NEMO versions
+    '''
+    for xx in XNAME :
+        if xx in dd.dims and xx != x :
+            if verbose :
+                print ( f"{xx} renamed to {x}" )
+            dd = dd.rename ( {xx:x})
+
+    for yy in YNAME :
+        if yy in dd.dims and yy != y  :
+            if verbose :
+                print ( f"{yy} renamed to {y}" )
+            dd = dd.rename ( {yy:y} )
+
+    for zz in ZNAME :
+        if zz in dd.dims and zz != z :
+            if verbose :
+                print ( f"{zz} renamed to {z}" )
+            dd = dd.rename ( {zz:z} )
+
+    for tt in TNAME  :
+        if tt in dd.dims and tt != t :
+            if verbose :
+                print ( f"{tt} renamed to {t}" )
+            dd = dd.rename ( {tt:t} )
+
+    return dd
+
+
+if SimpleImputer : 
+  def fill_empty (ptab, sval=np.nan, transpose=False) :
+        '''Fill empty values
+
+        Useful when NEMO has run with no wet points options :
+        some parts of the domain, with no ocean points, have no
+        values
+        '''
+        mmath = __mmath__ (ptab)
+
+        imp = SimpleImputer (missing_values=sval, strategy='mean')
+        if transpose :
+            imp.fit (ptab.T)
+            ztab = imp.transform (ptab.T).T
+        else :
+            imp.fit (ptab)
+            ztab = imp.transform (ptab)
+
+        if mmath == xr :
+            ztab = xr.DataArray (ztab, dims=ztab.dims, coords=ztab.coords)
+            ztab.attrs.update (ptab.attrs)
+
+        return ztab
+
     
-    fixed_lon = lon.copy ()
-        
-    fixed_lon = mmath.where (fixed_lon > center_lon+180., fixed_lon-360.0, fixed_lon)
-    fixed_lon = mmath.where (fixed_lon < center_lon-180., fixed_lon+360.0, fixed_lon)
-    
-    for i, start in enumerate (np.argmax (np.abs (np.diff (fixed_lon, axis=-1)) > 180., axis=-1)) :
-        fixed_lon [..., i, start+1:] += 360.
-
-    # Special case for eORCA025
-    if fixed_lon.shape [-1] == 1442 : fixed_lon [..., -2, :] = fixed_lon [..., -3, :]
-    if fixed_lon.shape [-1] == 1440 : fixed_lon [..., -1, :] = fixed_lon [..., -2, :]
-
-    if fixed_lon.min () > center_lon : fixed_lon += -360.0
-    if fixed_lon.max () < center_lon : fixed_lon +=  360.0
-        
-    if fixed_lon.min () < center_lon-360.0 : fixed_lon +=  360.0
-    if fixed_lon.max () > center_lon+360.0 : fixed_lon += -360.0
-                
-    return fixed_lon
-
-#@numba.jit(forceobj=True)
-def fill_empty (ztab, sval=np.nan, transpose=False) :
-    '''
-    Fill values
-
-    Useful when NEMO has run with no wet points options : 
-    some parts of the domain, with no ocean points, has no
+else : 
+    print ("Import error of sklearn.impute.SimpleImputer")
+    def fill_empty (ptab, sval=np.nan, transpose=False) :
+        '''Void version of fill_empy, because module sklearn.impute.SimpleImputer is not available
+
+        fill_empty : 
+          Fill values
+
+          Useful when NEMO has run with no wet points options :
+          some parts of the domain, with no ocean points, have no
+          values
+        '''
+        print ( 'Error : module sklearn.impute.SimpleImputer not found' )
+        print ( 'Can not call fill_empty' )
+        print ( 'Call arguments where : ' )
+        print ( f'{ptab.shape=} {sval=} {transpose=}' )
+  
+def fill_lonlat (plon, plat, sval=-1) :
+    '''Fill longitude/latitude values
+
+    Useful when NEMO has run with no wet points options :
+    some parts of the domain, with no ocean points, have no
     lon/lat values
     '''
-    mmath = __mmath__ (ztab)
+    from sklearn.impute import SimpleImputer
+    mmath = __mmath__ (plon)
 
     imp = SimpleImputer (missing_values=sval, strategy='mean')
-    if transpose :
-        imp.fit (ztab.T)
-        ptab = imp.transform (ztab.T).T
-    else : 
-        imp.fit (ztab)
-        ptab = imp.transform (ztab)
-   
+    imp.fit (plon)
+    zlon = imp.transform (plon)
+    imp.fit (plat.T)
+    zlat = imp.transform (plat.T).T
+
     if mmath == xr :
-        ptab = xr.DataArray (ptab, dims=ztab.dims, coords=ztab.coords)
-        ptab.attrs = ztab.attrs
-        
-    return ptab
-
-#@numba.jit(forceobj=True)
-def fill_lonlat (lon, lat, sval=-1) :
-    '''
-    Fill longitude/latitude values
-
-    Useful when NEMO has run with no wet points options : 
+        zlon = xr.DataArray (zlon, dims=plon.dims, coords=plon.coords)
+        zlat = xr.DataArray (zlat, dims=plat.dims, coords=plat.coords)
+        zlon.attrs.update (plon.attrs)
+        zlat.attrs.update (plat.attrs)
+
+    zlon = fixed_lon (zlon)
+
+    return zlon, zlat
+
+def fill_bounds_lonlat (pbounds_lon, pbounds_lat, sval=-1) :
+    '''Fill longitude/latitude bounds values
+
+    Useful when NEMO has run with no wet points options :
     some parts of the domain, with no ocean points, as no
     lon/lat values
     '''
-    mmath = __mmath__ (lon)
+    mmath = __mmath__ (pbounds_lon)
+
+    z_bounds_lon = np.empty ( pbounds_lon.shape )
+    z_bounds_lat = np.empty ( pbounds_lat.shape )
 
     imp = SimpleImputer (missing_values=sval, strategy='mean')
-    imp.fit (lon)
-    plon = imp.transform (lon)
-    imp.fit (lat.T)
-    plat = imp.transform (lat.T).T
+
+    for n in np.arange (4) :
+        imp.fit (pbounds_lon[:,:,n])
+        z_bounds_lon[:,:,n] = imp.transform (pbounds_lon[:,:,n])
+        imp.fit (pbounds_lat[:,:,n].T)
+        z_bounds_lat[:,:,n] = imp.transform (pbounds_lat[:,:,n].T).T
 
     if mmath == xr :
-        plon = xr.DataArray (plon, dims=lon.dims, coords=lon.coords)
-        plat = xr.DataArray (plat, dims=lat.dims, coords=lat.coords)
-        plon.attrs = lon.attrs ; plat.attrs = lat.attrs
-        
-    plon = fixed_lon (plon)
-    
-    return plon, plat
-
-#@numba.jit(forceobj=True)
-def jeq (lat) :
-    '''
-    Returns j index of equator in the grid
-    
+        z_bounds_lon = xr.DataArray (pbounds_lon, dims=pbounds_lon.dims,
+                                         coords=pbounds_lon.coords)
+        z_bounds_lat = xr.DataArray (pbounds_lat, dims=pbounds_lat.dims,
+                                         coords=pbounds_lat.coords)
+        z_bounds_lon.attrs.update (pbounds_lat.attrs)
+        z_bounds_lat.attrs.update (pbounds_lat.attrs)
+
+    return z_bounds_lon, z_bounds_lat
+
+def jeq (plat) :
+    '''Returns j index of equator in the grid
+
     lat : latitudes of the grid. At least 2D.
     '''
-    mmath = __mmath__ (lat)
-    ix, ax = __findAxis__ (lat, 'x')
-    iy, ay = __findAxis__ (lat, 'y')
+    mmath = __mmath__ (plat)
+    jy = __find_axis__ (plat, 'y')[-1]
 
     if mmath == xr :
-        jeq = int ( np.mean ( np.argmin (np.abs (np.float64 (lat)), axis=iy) ) )
-    else : 
-        jeq = np.argmin (np.abs (np.float64 (lat[...,:, 0])))
-    return jeq
-
-#@numba.jit(forceobj=True)
-def lon1D (lon, lat=None) :
-    '''
-    Returns 1D longitude for simple plots.
-    
-    lon : longitudes of the grid
-    lat (optionnal) : latitudes of the grid
-    '''
-    mmath = __mmath__ (lon)
-    if np.max (lat) != None :
-        je    = jeq (lat)
-        lon1D = lon.copy() [..., je, :]
-    else :
-        jpj, jpi = lon.shape [-2:]
-        lon1D    = lon.copy() [..., jpj//3, :]
-
-    start = np.argmax (np.abs (np.diff (lon1D, axis=-1)) > 180.0, axis=-1)
-    lon1D [..., start+1:] += 360
+        jj = int ( np.mean ( np.argmin (np.abs (np.float64 (plat)),
+                                                axis=jy) ) )
+    else :
+        jj = np.argmin (np.abs (np.float64 (plat[...,:, 0])))
+
+    return jj
+
+def lon1d (plon, plat=None) :
+    '''Returns 1D longitude for simple plots.
+
+    plon : longitudes of the grid
+    plat (optionnal) : latitudes of the grid
+    '''
+    mmath = __mmath__ (plon)
+    jpj, jpi  = plon.shape [-2:]
+    if np.max (plat) :
+        je    = jeq (plat)
+        lon0 = plon [..., je, 0].copy()
+        dlon = plon [..., je, 1].copy() - plon [..., je, 0].copy()
+        lon_1d = np.linspace ( start=lon0, stop=lon0+360.+2*dlon, num=jpi )
+    else :
+        lon0 = plon [..., jpj//3, 0].copy()
+        dlon = plon [..., jpj//3, 1].copy() - plon [..., jpj//3, 0].copy()
+        lon_1d = np.linspace ( start=lon0, stop=lon0+360.+2*dlon, num=jpi )
+
+    #start = np.argmax (np.abs (np.diff (lon1D, axis=-1)) > 180.0, axis=-1)
+    #lon1D [..., start+1:] += 360
 
     if mmath == xr :
-        lon1D.attrs = lon.attrs
-        lon1D = lon1D.assign_coords ( {'x':lon1D} )
-        
-    return lon1D
-
-#@numba.jit(forceobj=True)
-def latreg (lat, diff=0.1) :
-    '''
-    Returns maximum j index where gridlines are along latitudes in the northern hemisphere
-    
+        lon_1d = xr.DataArray( lon_1d, dims=('lon',), coords=(lon_1d,))
+        lon_1d.attrs.update (plon.attrs)
+        lon_1d.attrs['units']         = 'degrees_east'
+        lon_1d.attrs['standard_name'] = 'longitude'
+        lon_1d.attrs['long_name :']   = 'Longitude'
+
+    return lon_1d
+
+def latreg (plat, diff=0.1) :
+    '''Returns maximum j index where gridlines are along latitudes
+    in the northern hemisphere
+
     lat : latitudes of the grid (2D)
     diff [optional] : tolerance
     '''
-    mmath = __mmath__ (lat)
-    if diff == None :
-        dy   = np.float64 (np.mean (np.abs (lat - np.roll (lat,shift=1,axis=-2, roll_coords=False))))
+    #mmath = __mmath__ (plat)
+    if diff is None :
+        dy = np.float64 (np.mean (np.abs (plat -
+                        np.roll (plat,shift=1,axis=-2, roll_coords=False))))
+        print ( f'{dy=}' )
         diff = dy/100.
-    
-    je     = jeq (lat)
-    jreg   = np.where (lat[...,je:,:].max(axis=-1) - lat[...,je:,:].min(axis=-1)< diff)[-1][-1] + je
-    latreg = np.float64 (lat[...,jreg,:].mean(axis=-1))
-    JREG   = jreg
-
-    return jreg, latreg
-
-#@numba.jit(forceobj=True)
-def lat1D (lat) :
-    '''
-    Returns 1D latitudes for zonal means and simple plots.
-
-    lat : latitudes of the grid (2D)
-    '''
-    mmath = __mmath__ (lat)
-    jpj, jpi = lat.shape[-2:]
-
-    dy     = np.float64 (np.mean (np.abs (lat - np.roll (lat, shift=1,axis=-2))))
-    je     = jeq (lat)
-    lat_eq = np.float64 (lat[...,je,:].mean(axis=-1))
-      
-    jreg, lat_reg = latreg (lat)
-    lat_ave = np.mean (lat, axis=-1)
-
-    if (np.abs (lat_eq) < dy/100.) : # T, U or W grid
-        dys    = (90.-lat_reg) / (jpj-jreg-1)*0.5
+
+    je     = jeq (plat)
+    jreg   = np.where (plat[...,je:,:].max(axis=-1) -
+                       plat[...,je:,:].min(axis=-1)< diff)[-1][-1] + je
+    lareg  = np.float64 (plat[...,jreg,:].mean(axis=-1))
+
+    return jreg, lareg
+
+def lat1d (plat) :
+    '''Returns 1D latitudes for zonal means and simple plots.
+
+    plat : latitudes of the grid (2D)
+    '''
+    mmath = __mmath__ (plat)
+    iy = __find_axis__ (plat, 'y')[-1]
+    jpj = plat.shape[iy]
+
+    dy     = np.float64 (np.mean (np.abs (plat - np.roll (plat, shift=1,axis=-2))))
+    je     = jeq (plat)
+    lat_eq = np.float64 (plat[...,je,:].mean(axis=-1))
+
+    jreg, lat_reg = latreg (plat)
+    lat_ave = np.mean (plat, axis=-1)
+
+    if np.abs (lat_eq) < dy/100. : # T, U or W grid
+        if jpj-1 > jreg :
+            dys = (90.-lat_reg) / (jpj-jreg-1)*0.5
+        else            :
+            dys = (90.-lat_reg) / 2.0
         yrange = 90.-dys-lat_reg
     else                           :  # V or F grid
-        yrange = 90.    -lat_reg
-        
-    lat1D = mmath.where (lat_ave<lat_reg, lat_ave, lat_reg + yrange * (np.arange(jpj)-jreg)/(jpj-jreg-1))   
-        
+        yrange = 90.-lat_reg
+
+    if jpj-1 > jreg :
+        lat_1d = mmath.where (lat_ave<lat_reg,
+                 lat_ave,
+                 lat_reg + yrange * (np.arange(jpj)-jreg)/(jpj-jreg-1) )
+    else :
+        lat_1d = lat_ave
+    lat_1d[-1] = 90.0
+
     if mmath == xr :
-        lat1D.attrs = lat.attrs
-        lat1D = lat1D.assign_coords ( {'y':lat1D} )
-
-    return lat1D
-
-#@numba.jit(forceobj=True)
-def latlon1D (lat, lon) :
-    '''
-    Returns simple latitude and longitude (1D) for simple plots.
-
-    lat, lon : latitudes and longitudes of the grid (2D)
-    '''
-    return lat1D (lat),  lon1D (lon, lat)
-
-##@numba.jit(forceobj=True)
+        lat_1d = xr.DataArray( lat_1d.values, dims=('lat',), coords=(lat_1d,))
+        lat_1d.attrs.update (plat.attrs)
+        lat_1d.attrs ['units']         = 'degrees_north'
+        lat_1d.attrs ['standard_name'] = 'latitude'
+        lat_1d.attrs ['long_name :']   = 'Latitude'
+
+    return lat_1d
+
+def latlon1d (plat, plon) :
+    '''Returns simple latitude and longitude (1D) for simple plots.
+
+    plat, plon : latitudes and longitudes of the grid (2D)
+    '''
+    return lat1d (plat),  lon1d (plon, plat)
+
+def ff (plat) :
+    '''Returns Coriolis factor
+    '''
+    zff   = np.sin (RAD * plat) * OMEGA
+    return zff
+
+def beta (plat) :
+    '''Return Beta factor (derivative of Coriolis factor)
+    '''
+    zbeta = np.cos (RAD * plat) * OMEGA / RA
+    return zbeta
+
 def mask_lonlat (ptab, x0, x1, y0, y1, lon, lat, sval=np.nan) :
+    '''Returns masked values outside a lat/lon box
+    '''
     mmath = __mmath__ (ptab)
-    try :
+    if mmath == xr :
         lon = lon.copy().to_masked_array()
         lat = lat.copy().to_masked_array()
-    except : pass
-            
-    mask = np.logical_and (np.logical_and(lat>y0, lat<y1), 
-            np.logical_or (np.logical_or (np.logical_and(lon>x0, lon<x1), np.logical_and(lon+360>x0, lon+360<x1)),
-                                      np.logical_and(lon-360>x0, lon-360<x1)))
-    tab = mmath.where (mask, ptab, np.nan)
-    
+
+    mask = np.logical_and (np.logical_and(lat>y0, lat<y1),
+            np.logical_or (np.logical_or (
+                np.logical_and(lon>x0, lon<x1),
+                np.logical_and(lon+360>x0, lon+360<x1)),
+                np.logical_and(lon-360>x0, lon-360<x1)))
+    tab = mmath.where (mask, ptab, sval)
+
     return tab
 
-#@numba.jit(forceobj=True)      
-def extend (tab, Lon=False, jplus=25, jpi=None, nperio=4) :
-    '''
-    Returns extended field eastward to have better plots, and box average crossing the boundary
+def extend (ptab, blon=False, jplus=25, jpi=None, nperio=4) :
+    '''Returns extended field eastward to have better plots,
+    and box average crossing the boundary
+
     Works only for xarray and numpy data (?)
-
-    tab : field to extend.
-    Lon : (optional, default=False) : if True, add 360 in the extended parts of the field
-    jpi : normal longitude dimension of the field. exrtend does nothing it the actual
-        size of the field != jpi (avoid to extend several times)
-    jplus (optional, default=25) : number of points added on the east side of the field
-    
-    '''
-    mmath = __mmath__ (tab)
-    
-    if tab.shape[-1] == 1 : extend = tab
-
-    else :
-        if jpi == None : jpi = tab.shape[-1]
-
-        if Lon : xplus = -360.0
-        else   : xplus =    0.0
-
-        if tab.shape[-1] > jpi :
-            extend = tab
+    Useful for plotting vertical sections in OCE and ATM.
+
+    ptab : field to extend.
+    blon  : (optional, default=False) : if True, add 360 in the extended
+          parts of the field
+    jpi   : normal longitude dimension of the field. extend does nothing
+          if the actual size of the field != jpi
+          (avoid to extend several times in notebooks)
+    jplus (optional, default=25) : number of points added on
+          the east side of the field
+
+    '''
+    mmath = __mmath__ (ptab)
+
+    if ptab.shape[-1] == 1 :
+        tabex = ptab
+
+    else :
+        if jpi is None :
+            jpi = ptab.shape[-1]
+
+        if blon :
+            xplus = -360.0
+        else   :
+            xplus =    0.0
+
+        if ptab.shape[-1] > jpi :
+            tabex = ptab
         else :
-            if nperio == 0 or nperio == 4.2 :
-                istart = 0 ; le=jpi+1 ; la=0
+            if nperio in [ 0, 4.2 ] :
+                istart, le, la = 0, jpi+1, 0
             if nperio == 1 :
-                istart = 0 ; le=jpi+1 ; la=0
-            if nperio == 4 or nperio == 6 : # OPA case with two halo points for periodicity
-                istart = 1 ; le=jpi-2 ; la=1  # Perfect, except at the pole that should be masked by lbc_plot
-           
+                istart, le, la = 0, jpi+1, 0
+            if nperio in [4, 6] : # OPA case with two halo points for periodicity
+                # Perfect, except at the pole that should be masked by lbc_plot
+                istart, le, la = 1, jpi-2, 1
             if mmath == xr :
-                extend = np.concatenate ((tab.values[..., istart   :istart+le+1    ] + xplus,
-                                          tab.values[..., istart+la:istart+la+jplus]         ), axis=-1)
-                lon    = tab.dims[-1]
+                tabex = np.concatenate (
+                     (ptab.values[..., istart   :istart+le+1    ] + xplus,
+                      ptab.values[..., istart+la:istart+la+jplus]         ),
+                      axis=-1)
+                lon    = ptab.dims[-1]
                 new_coords = []
-                for coord in tab.dims :
-                    if coord == lon : new_coords.append ( np.arange( extend.shape[-1]))
-                    else            : new_coords.append ( tab.coords[coord].values)
-                extend = xr.DataArray ( extend, dims=tab.dims, coords=new_coords )
-            else : 
-                extend = np.concatenate ((tab [..., istart   :istart+le+1    ] + xplus,
-                                          tab [..., istart+la:istart+la+jplus]          ), axis=-1)
-    return extend
-
-def orca2reg (ff, lat_name='nav_lat', lon_name='nav_lon', y_name='y', x_name='x') :
-    '''
-    Assign an ORCA dataset on a regular grid.
+                for coord in ptab.dims :
+                    if coord == lon :
+                        new_coords.append ( np.arange( tabex.shape[-1]))
+                    else            :
+                        new_coords.append ( ptab.coords[coord].values)
+                tabex = xr.DataArray ( tabex, dims=ptab.dims,
+                                           coords=new_coords )
+            else :
+                tabex = np.concatenate (
+                    (ptab [..., istart   :istart+le+1    ] + xplus,
+                     ptab [..., istart+la:istart+la+jplus]          ),
+                     axis=-1)
+    return tabex
+
+def orca2reg (dd, lat_name='nav_lat', lon_name='nav_lon',
+                  y_name='y', x_name='x') :
+    '''Assign an ORCA dataset on a regular grid.
+
     For use in the tropical region.
-    
-    Inputs : 
+    Inputs :
       ff : xarray dataset
       lat_name, lon_name : name of latitude and longitude 2D field in ff
       y_name, x_name     : namex of dimensions in ff
-      
+
       Returns : xarray dataset with rectangular grid. Incorrect above 20Â°N
     '''
     # Compute 1D longitude and latitude
-    (lat, lon) = latlon1D (ff[lat_name], ff[lon_name])
-
+    (zlat, zlon) = latlon1d ( dd[lat_name], dd[lon_name])
+
+    zdd = dd
     # Assign lon and lat as dimensions of the dataset
-    if y_name in ff.dims : 
-        lat = xr.DataArray (lat, coords=[lat,], dims=['lat',])     
-        ff  = ff.rename_dims ({y_name: "lat",}).assign_coords (lat=lat)
-    if x_name in ff.dims :
-        lon = xr.DataArray (lon, coords=[lon,], dims=['lon',])
-        ff  = ff.rename_dims ({x_name: "lon",}).assign_coords (lon=lon)
+    if y_name in zdd.dims :
+        zlat = xr.DataArray (zlat, coords=[zlat,], dims=['lat',])
+        zdd  = zdd.rename_dims ({y_name: "lat",}).assign_coords (lat=zlat)
+    if x_name in zdd.dims :
+        zlon = xr.DataArray (zlon, coords=[zlon,], dims=['lon',])
+        zdd  = zdd.rename_dims ({x_name: "lon",}).assign_coords (lon=zlon)
     # Force dimensions to be in the right order
     coord_order = ['lat', 'lon']
     for dim in [ 'depthw', 'depthv', 'depthu', 'deptht', 'depth', 'z',
-                 'time_counter', 'time', 'tbnds', 
+                 'time_counter', 'time', 'tbnds',
                  'bnds', 'axis_nbounds', 'two2', 'two1', 'two', 'four',] :
-        if dim in ff.dims : coord_order.insert (0, dim)
-        
-    ff = ff.transpose (*coord_order)
-    return ff
+        if dim in zdd.dims :
+            coord_order.insert (0, dim)
+
+    zdd = zdd.transpose (*coord_order)
+    return zdd
 
 def lbc_init (ptab, nperio=None) :
-    '''
-    Prepare for all lbc calls
-    
+    '''Prepare for all lbc calls
+
     Set periodicity on input field
     nperio    : Type of periodicity
